import { AfterContentInit, ElementRef, OnInit } from '@angular/core';
export declare class NgStaticGridCanvasComponent implements OnInit, AfterContentInit {
    private hostElement;
    canvas: ElementRef;
    /** The element to cover */
    coverElement?: ElementRef;
    /**
     * Optional color of the shadow.
     * @optional default #343a40
     */
    shadowColor?: string;
    /**
     * Optional global alpha to set.
     */
    alpha?: number;
    gridStartX: number;
    gridEndX: number;
    gridStartY: number;
    gridEndY: number;
    /**
     * Takes the min of width or hight and mutiplies it with this number.
     * So that the line scales with the available screen size.
     */
    strokeGridFactor: number;
    /**
     * Position of the error head
     * @values bottom | top
     * @memberof NgStaticGridCanvasComponent
     */
    arrowHead: string;
    private _xFactor;
    private _yFactor;
    private _contentSet;
    constructor(hostElement: ElementRef);
    private _reversed;
    reversed: boolean;
    private _lineType;
    lineType: string;
    private _strokeStyle;
    /**
    * Set the color of the line.
    * @see https://www.w3schools.com/colors/colors_picker.asp
    */
    strokeStyle: string | CanvasGradient | CanvasPattern;
    private _gridSizeX;
    /**
    * Int number how many columns
    * @memberof NgStaticGridCanvasComponent
    */
    gridSizeX: number;
    columns: number;
    private _gridSizeY;
    gridSizeY: number;
    rows: number;
    ngOnInit(): void;
    ngAfterContentInit(): void;
    onResize(event: any): void;
    doRedraw(): void;
    adjustCanvas(height: number, width: number): void;
    prepareLine(): void;
    private drawReversedSLine;
    private drawSLine;
    private drawULine;
    private drawReversedULine;
    /**
     * A method to draw an arrow on the canvas
     * @param context is the canvas context
     * @param leftArrowPointX is the X coordinate of the Point which is located on the left bottom part of the arrow
     * @param leftArrowPointY is the Y coordinate of the Point which is located on the left bottom part of the arrow
     * @param lineWidthX is X coordinate Width of the arrow
     * @param lineWidthY is Y coordinate Width of the arrow
     * @param direction is the direction in which the arrow should point to
     */
    private drawCanvasArrow;
    /**
     * A Method to draw from a specific corner a curve
     * @param context is the canvas context
     * @param cornerX is the X coordinate of the corner
     * @param cornerY is the Y coordinate of the corner
     * @param radius is the radius of the curve
     * @param direction is the direction in which the final curve should point to
     * @param curve specifies if it should be a left or a right curve
     * @param lineWidth for outer line curves the lineWidth is needed to adjust the radius
     */
    private drawCurve;
}
