import { OnInit, Renderer2, ElementRef } from '@angular/core';
import { NgStaticGridItemModel } from './item.model';
/**
 * Any item can have x and y coordinates and a width and hight.
 *
 * x / y are 0 based.
 */
export declare class NgStaticGridItemComponent implements OnInit {
    private renderer;
    hostElement: ElementRef;
    /**
     * To save and restore the postion each items needs an ID to be identified.
     */
    id?: string;
    x?: number;
    y?: number;
    width?: number;
    height?: number;
    constructor(renderer: Renderer2, hostElement: ElementRef);
    ngOnInit(): void;
    /** Applies the given model to the attributes */
    setModel(val: NgStaticGridItemModel): void;
    /**
     * Builds the model from the current attributes.
     */
    getModel(): NgStaticGridItemModel;
    doPosition(width: number, height: number): void;
}
